##############################################################################
import datetime





##############################################################################
ERR_HARD = 'hard'
ERR_SOFT = 'soft'




##############################################################################
class error:

  ##############################################################################
  def __init__( self ):

    self.__error_stack = []

    return

  ##############################################################################
  def is_error( self ):

    if len(self.__error_stack) > 0:
      return True
    else:
      return False

    return

  ##############################################################################
  def is_error_hard( self ):

    for error in self.__error_stack:
      if error[1] == ERR_HARD:
        return True

    return False

  ##############################################################################
  def is_error_soft( self ):

    for error in self.__error_stack:
      if error[1] == ERR_HARD:
        return False

    return True

  ##############################################################################
  def is_okay( self ):

    if len(self.__error_stack) > 0:
      return False
    else:
      return True

    return

  ##############################################################################
  def append( self, error_state ):

    for error_tuple in error_state.__error_stack:
      self.submit( error_tuple[1], error_tuple[2], error_tuple[3], error_tuple[4] )

    return

  ##############################################################################
  def submit( self, type, module, function, description ):

    self.__error_stack.insert( 0, (datetime.datetime.utcnow(), type, module, function, description) )

    return

  ##############################################################################
  def submit_on_error( self, type, module, function, description ):

    if self.is_error():
      self.submit( type, module, function, description )

    return

  ##############################################################################
  def clear( self ):

    self.__error_stack = []

    return

  ##############################################################################
  def generate_html_string( self, table_class ):

    if table_class == None:
      table_class_string = ''
    else:
      table_class_string = ' class="%s"' % (table_class)

    html_string_list = [ '    <table%s>' % (table_class_string), '      <thead>', '        <tr><th colspan="5">Error Report</th></tr>', '        <tr><th>Timestamp</th> <th>Type</th> <th>Module</th> <th>Function</th> <th>Description</th></tr>', '      </thead>\n', '      <tbody>' ]
    for error in self.__error_stack:
      timestamp   = error[0]
      type        = error[1]
      module      = error[2]
      function    = error[3]
      description = error[4]
      html_string_list.append( "        <tr><td>%s</td> <td>%s</td> <td>%s</td> <td>%s</td> <td>%s</td></tr>" % (timestamp, type, module, function, description) )
    html_string_list.extend( ['      </tbody>', '    </table>\n\n'] )

    return "\n".join( html_string_list )

  ##############################################################################
  def generate_string( self ):

    string_list = [ "Timestamp\tType\tModule\tFunction\tDescription" ]
    for error in self.__error_stack:
      timestamp   = error[0]
      type        = error[1]
      module      = error[2]
      function    = error[3]
      description = error[4]
      string_list.append( "%s\t%s\t%s\t%s\t%s" % (timestamp, type, module, function, description) )

    return "\n".join( string_list )

  ##############################################################################
  def print_on_error( self ):

    if self.is_error():
      error_report = self.generate_string()
      print( error_report )

  ##############################################################################
  def store_on_error( self, pathname ):

    if self.is_error():
      error_report = self.generate_string()
      log_file = open( pathname, 'a' )
      string = "%s : %s\n" % (datetime.datetime.utcnow(), log_message)
      log_file.write( string )
      log_file.close()

